import os, time
from os.path import *
import gnomeapplet, gtk, gtk.gdk, gconf, gobject
from gettext import gettext as _
import gtk, gtk.glade, egg.trayicon, gobject, gnomevfs
import csv, os

import invest, invest.about, invest.chart, invest.dbusnotification
import ustime

def get_quotes(callback, force=False):
	if not force and not ustime.hour_between(9, 16):
		return True
	print 'Get uotes:', invest.STOCKS
	if len(invest.STOCKS) == 0:
		return True
		
	s = ""
	for ticker in invest.STOCKS.keys():
		s += "%s+" % ticker
	
	gnomevfs.async.open(invest.QUOTES_URL % {"s": s[:-1]}, lambda h,e: on_quotes_open(h,e,callback))
	return True
	
def on_quotes_open(handle, exc_type, callback):
	if not exc_type:
		handle.read(invest.GNOMEVFS_CHUNK_SIZE, lambda h,d,e,b: on_quotes_read(h,d,e,b, "", callback))
	else:
		handle.close(lambda *args: None)	

def on_quotes_read(handle, data, exc_type, bytes_requested, read, callback):
	if not exc_type:
		read += data
		
	if exc_type:
		handle.close(lambda *args: None)
		callback(parse_yahoo_csv(csv.reader(read.split("\n"))))
	else:
		handle.read(invest.GNOMEVFS_CHUNK_SIZE, lambda h,d,e,b: on_quotes_read(h,d,e,b, read, callback))

def parse_yahoo_csv(csvreader):
	result = {}
	for fields in csvreader:
		if len(fields) == 0:
			continue

		result[fields[0]] = {}
		for i, field in enumerate(invest.QUOTES_CSV_FIELDS):
			if type(field) == tuple:
				result[fields[0]][field[0]] = field[1](fields[i])
			else:
				result[fields[0]][field] = fields[i]
				
	return result 
